# Ejercicio de JavaScript 003

**Roshka**

**Bootcamp 004**

**Fecha**: 2018-10-16

**Tiempo Estimado del Ejercicio**: 4 horas

##Teoria

##Strings  

##Métodos
    length
        Obtiene la longitud del string
    toUpperCase
        Convierte el string a mayúscula
    toLowerCase
        Convierte el string a minúscula
    indexOf
        El método indexOf() retorna el primer índice en el que se puede encontrar un elemento dado en el array, ó retorna -1 si el elemento no esta presente.
    trim: elimina los espacios en blanco de una cadena.
    trimRight
    trimLeft
        var greeting = '   Hello world!   ';

        console.log(greeting);
        // expected output: "   Hello world!   ";

        console.log(greeting.trimStart());
        // expected output: "Hello world!   ";

    charAt
        var str = "HELLO WORLD";
        var res = str.charAt(0)
    substring 
        var res = str.substring(1, 4);


##Arrays
Arrays son objetos regulares en los cuales hay una particular relacion entre la propiedad  clave-entera y la propiedad 'length'. Ademas, los arrays derivan de Array.prototype el cual les proporciona algunos metodos convenientes para manipularlos. Por ejemplo, indexOf (buscar un valor en el array) o push (agregar un elemento en el array), etc. Esto hace de los Arrays candidatos perfectos para representar lists o sets.

##Métodos

Tenemos:

    push: añade elementos al final de un array.
    pop: quita el último elemento de un array (o el del índice indicado).
    shift: El método shift elimina el elemento en el índice cero y desplaza los valores consecutivos hacia abajo, devolviendo el valor eliminado. Si la propiedad length es 0, devuelve undefined.
    unshift: Agrega uno o más elementos al inicio del array, y devuelve la nueva longitud del array.
    indexOf: para sacar el índice del primer elemento que se encuentra en un array.
    lastIndexOf: lo mismo pero encuentra el último índice.
    slice: extrae un trozo de array. slice(firstIndex, lastIndex) el primero se incluye y el segundo no.
    concat: pega dos arrays.




## Cuestionario

1. Qué son los arrays, como definimos los arrays en JS, 
2. Qué tipos de datos se pueden almacenar en los Arrays?
3. Podemos almacenar arrays y funciones en los Arrays?
4. Como reconocemos que una variable es un Array?
5. Para concatenar cadenas de caracteres en Javascript se usa el carácter?
6. Qué devuelve la siguiente función? (function(){
    return typeof arguments;
    })();
7. Las cadenas literales (constantes) como se escriben?
8. ¿Qué función se emplea para convertir una cadena a minúsculas?
9. Para obtener la longitud de la cadena "cad", se emplea
10. ¿Qué hace la sentencia continue?
11. Respecto a la declaración de variables, siempre se debe declarar las variables?

## Ejercicios

1. Escribir una funcion que imprima todos los numeros primos del 1 al 100 
2. Realizar el factorial de los primeros 50 numeros. Ej. 1, 2... 50
3. Escribir una funcion que determine si un número introducido es divisible por 11 y 5 o no, mostrar el resultado con console.log
4. Escribir una función que reciba la edad de una persona y determine si una persona es mayor de edad o menor de edad 
5. Escribir un programa que muestre un prompt donde el usuario ingresa un número, luego muestra otro prompt pidiendo otro número, finalmente el programa muestra una alerta con el resultado de la suma.
6. Crear un programa donde el usuario ingrese en un prompt la temperatura en Celcius y el programa muestre en una alerta la temperatura en Fahrenheit.
7. Pedir un número a un usuario a través de un prompt y luego dividirlo por 10, ejemplo: 5 / 10 igual 0.5
8. Escribir una funcion que devuelva el numero de dia de la semana pasandole el dia de la semana en letras
9. Realizar la suma de todos los números pares entre entre dos rango de numeros
10. Hacer una función que diga si una palabra es palíndrome una palabra es palindrome si se puede leer de la misma manera de ambos lados 
11.  Escribir una funcion que obtenga como parametro un array de numeros y devuelva una respuesta si esta ordenado devuelve "El array esta ordenado", sino "El array no esta ordenado"
12. Generar una copia de un array pero con todos los elementos incrementado en 1.
13. Crear una función que reciba un array y que cree uno nuevo con todos los elementos ordenados de menor a mayor
14. Crear una función que permite intercambiar las posiciones de dos elementos de un array en base a sus índices Ej. (0,1)
15. Crear un array con valores numericos ej: [5,8,12,16] luego calcular el promedio de los elementos 
16. Crear un array con los dias de la semana, crear una función que determine que dia de la semana es pasandole el id del dia

## Particularidades

1. Se puede utilizar cualquier editor de textos para escribir los ejercicios de JavaScript.
   Yo les recomiendo Visual Studio Code.
2. No se puede copiar NINGUNA SOLUCIÓN pre existente de *Internet*
3. Entregar un archivo en *Markdown* llamado `README.md` en la raiz del repositorio. En este archivo, 
   tienen que estar las instrucciones de cómo ver, ordenadamente, los ejercicios planteados acá para que
   los instructores puedan hacer las correcciones correspondientes. Indicar cómo encontrar la respuesta
   a cada pregunta del cuestionario y a cada ejercicio.

## Entrega

Crear un repositorio en GitLab: `https://phoebe.roshka.com/gitlab` en sus correspondientes usuarios que 
tenga el nombre de `js-e003`.
